Program Approximation_by_Increasing_Sequence;
{Solution by dynamical programming}
{Applying 2D array }

Const MaxN=2000;

Var xsort: Array [1..MaxN] of LongInt;

  Procedure QuickSort(L,R: LongInt);
  Var k, j: LongInt;
      treshold, w: LongInt;
  Begin
    k:=L; j:=R;
    treshold:=xsort[(L+R) div 2];
    Repeat
      While (xsort[k]<treshold) Do Inc(k);
      While (treshold<xsort[j]) Do Dec(j);
      If (k<=j) Then
      Begin
        w:=xsort[j]; xsort[j]:=xsort[k]; xsort[k]:=w;
        Inc(k); Dec(j);
      End;
    Until (k>j);
    If (L<j) Then QuickSort(L,j);
    If (k<R) Then QuickSort(k,R);
  End; {QuickSort}

Var x: Array [1..MaxN] of LongInt;
    res: Array [1..MaxN] of LongInt;
    aim: Array [1..MaxN, 1..MaxN] of Int64;
    n, i, j: LongInt;
    min: Int64;
    others: LongInt;
    f: Text;

Begin
{INPUT}
  Assign(f,'sequence.in'); Reset(f);
  Readln(f,n);
  min:= MaxLongInt;
  For i:= 1 To n Do Begin
    Readln(f,x[i]);
    Dec(x[i],i);
  End;
  Close(f);

{RENUMERATION}
  Move(x,xsort,SizeOf(x));
  QuickSort(1,n);
  others:= 1;
  i:= 2;
  While (i<=n) Do Begin
    If xsort[i]<>xsort[others] Then Begin
      Inc(others);
      xsort[others]:= xsort[i];
    End;
    Inc(i);
  End;

{SEARCH}
  {Direct motion}
  For j:= 1 To others Do Begin
    aim[1,j]:= abs(x[1]-xsort[j]);
  End;

  For i:= 2 To n Do Begin
    min:= aim[i-1,1];
    For j:= 1 To others Do Begin
      If min>aim[i-1,j] Then min:= aim[i-1,j];
      aim[i,j]:= min+abs(x[i]-xsort[j]);
    End;
  End;

  {Reverse motion}
  min:= aim[n,1];
  j:= 1;
  For i:= 2 To others Do Begin
    If min>aim[n,i] Then Begin
      min:= aim[n,i];
      j:= i;
    End;
  End;
  res[n]:= xsort[j];
  For i:= n-1 DownTo 1 Do Begin
    While (aim[i+1,j]<>aim[i,j]+abs(x[i+1]-xsort[j])) Do
      Dec(j);
    res[i]:= xsort[j];
  End;

{OUTPUT}
  Assign(f,'sequence.out'); Rewrite(f);
  Writeln(f,min);
  For i:= 1 To n Do Begin
    Writeln(f,res[i]+i);
  End;
  Close(f);
End.
