Program Approximation_by_Increasing_Sequence;
{Solution is based on Quick-approach}
{Median search by "reduced" QuickSort}

Const MaxN=1000000;

Var x, x2: Array [1..MaxN] of LongInt;
    y: Array [0..MaxN] of LongInt;

    Function Search(L,R: LongInt {boundaries}; K: LongInt {place}): LongInt;
    Var i, j: LongInt;
        treshold, w: LongInt;
    Begin
      i:=L; j:=R;
      treshold:=x[(L+R) div 2];
      Repeat
        While (x[i]<treshold) Do Inc(i);
        While (treshold<x[j]) Do Dec(j);
        If (i<=j) Then Begin
          w:=x[j]; x[j]:=x[i]; x[i]:=w;
          Inc(i); Dec(j);
        End;
      Until (i>j);

      If (j+1>=K+L) Then Begin
        Search:= Search(L, j, K);
      End
      Else Begin
        If (i<K+L) Then Begin
          Search:= Search(i, R, K+L-i);
        End
        Else Begin
          Search:= x[i-1];
        End;
      End;
    End;

Function Median(l, r: LongInt): LongInt;
Var w: LongInt;
Begin
  w:= Search(l, r, (r-l) div 2 + 1);
  Move(x2[l], x[l], (r-l+1)*SizeOf(LongInt));
  If (w >= y[l-1]) Then Median:= w
                   Else Median:= y[l-1];
End;

Procedure Build(l, r: LongInt);
Var med: LongInt;
    countdown, lastdown, countmax: LongInt;
    i: LongInt;
Begin
    med:= Median(l,r);
    countdown:= 0;
    countmax:= 0;
    lastdown:= r;
    For i:= l To (r-2) Do Begin
      If x[i]<med Then Begin
        Inc(countdown);
        If countdown>countmax Then Begin
           lastdown:=i;
           countmax:= countdown;
        End;
      End
      Else Begin
        Dec(countdown);
      End;
    End;
    If lastdown<r Then Begin
      Build(l, lastdown);
      Build(lastdown+1, r);
    End
    Else Begin
      countdown:= 0;
      countmax:= 0;
      For i:= l To r Do Begin
        If x[i]<=med Then Begin
          Inc(countdown);
          If countdown>=countmax Then Begin
            lastdown:=i;
            countmax:= countdown;
          End;
        End
        Else Begin
          Dec(countdown);
        End;
      End;
      For i:= l To lastdown Do Begin
        y[i]:= med;
      End;
      If lastdown<r Then Begin
        Build(lastdown+1,r);
      End;
    End;
End;

Var n, i: LongInt;
    sum: Int64;
    f: Text;

Begin
  Assign(f,'sequence.in'); Reset(f);
  Readln(f,n);
  For i:= 1 To n Do Begin
    Readln(f,x[i]);
    Dec(x[i],i);
  End;
  Move(x, x2, SizeOf(x2));
  Close(f);
  y[0]:= -MaxLongInt;
  Build(1,n);
  Assign(f,'sequence.out'); Rewrite(f);
  sum:= 0;
  For i:= 1 To n Do Begin
    Inc(sum,abs(x2[i]-y[i]));
  End;
  Writeln(f,sum);
  For i:= 1 To n Do Begin
    Writeln(f,y[i]+i);
  End;
  Close(f);
End.
