Program Approximation_by_Increasing_Sequence;
{Solution is based on Quick-approach}
{Median search with O(N) complexity }

Const MaxN=1000000;

Var x, x2: Array [1..MaxN] of LongInt;
    y: Array [0..MaxN] of LongInt;
    n, i: LongInt;
    sum: INt64;
    f: Text;

Function Choise(N1, N2{boundaries}, k{-th place}: LongInt): LongInt;
Const N7 = MaxN div 7;
Var a1: Array [1..N7] of LongInt;
    b: Array [1..7] of LongInt;
    i, j, p, M: LongInt;
    R, w: LongInt;
Begin
  If (N2-N1) < 7  Then Begin
    For i:=N1 To N2 Do b[i+1-N1]:= x[i];
    For i:= 1 To N2-N1 Do
      For j:= i+1 To N2+1-N1 Do
        If b[i]>b[j] Then Begin
          w:=b[j]; b[j]:=b[i]; b[i]:=w;
        End;
    R:=b[k];
  End
  Else Begin  {N2-N1>=7}
    M:= (N2+1-N1) div 7;
    For i:=1 To M Do Begin
      a1[i]:= x[i];
      x[i]:=Choise(N1+7*i-7, N1+7*i-1, 4);
    End;
    R:= Choise(1, M, (M+1) div 2);
    For i:=1 To M Do x[i]:= a1[i];
    p:=N1; j:=N2; i:=N1;
    While x[j]>R Do Dec(j);
    Repeat
      If (x[i]<R)
      Then Begin
        x[p]:=x[i];
        Inc(i);  Inc(p);
      End
      Else
        If (x[i]>R)
        Then Begin
          w:=x[j]; x[j]:=x[i]; x[i]:=w;
          While x[j]>R Do Dec(j);
        End
        Else
          If (x[i]=R) Then Inc(i);
    Until (i>j);
    For j:=p To i-1 Do x[j]:=R;
    If (p >= N1+k)
    Then R:= Choise(N1, p-1, k)
    Else
      If (i < k+N1) Then R:= Choise(i, N2, k+N1-i);
  End;
  Choise:= R;
End; {Choise}

Function Median(l, r: LongInt): LongInt;
Var w: LongInt;
Begin
  w:= Choise(l, r, (r-l) div 2 + 1);
  Move(x2[l], x[l], (r-l+1)*4);
  If (w >= y[l-1]) Then Median:= w
                     Else Median:= y[l-1];
End;

Procedure Build(l, r: LongInt);
Var med: LongInt;
    countdown, lastdown, countmax: LongInt;
    i: LongInt;
Begin
    med:= Median(l,r);
    countdown:= 0;
    countmax:= 0;
    lastdown:= r;
    For i:= l To (r-2) Do Begin
      If x[i]<med Then Begin
        Inc(countdown);
        If countdown>countmax Then Begin
           lastdown:=i;
           countmax:= countdown;
        End;
      End
      Else Begin
        Dec(countdown);
      End;
    End;
    If lastdown<r Then Begin
      Build(l, lastdown);
      Build(lastdown+1, r);
    End
    Else Begin
      countdown:= 0;
      countmax:= 0;
      For i:= l To r Do Begin
        If x[i]<=med Then Begin
          Inc(countdown);
          If countdown>=countmax Then Begin
            lastdown:=i;
            countmax:= countdown;
          End;
        End
        Else Begin
          Dec(countdown);
        End;
      End;
      For i:= l To lastdown Do Begin
        y[i]:= med;
      End;
      If lastdown<r Then Begin
        Build(lastdown+1,r);
      End;
    End;
End;

Begin
  Assign(f,'sequence.in'); Reset(f);
  Readln(f,n);
  For i:= 1 To n Do Begin
    Readln(f,x[i]);
    Dec(x[i],i);
  End;
  Move(x, x2, SizeOf(x2));
  Close(f);
  y[0]:= -MaxLongInt;
  Build(1,n);
  Assign(f,'sequence.out'); Rewrite(f);
  sum:= 0;
  For i:= 1 To n Do Begin
    Inc(sum,abs(x2[i]-y[i]));
  End;
  Writeln(f,sum);
  For i:= 1 To n Do Begin
    Writeln(f,y[i]+i);
  End;
  Close(f);
End.
